                 /*ͻ
                  C Easy sampleb.c: Database Interfacing 
                 */

int retrieve();                 // edit function declared

int F3_Key();                   // F3 event function declared
int F4_Key();                   // F4 event function declared
                                // F4 treated same as Esc Key
#include "ceasy1.h"
#include "names.h"              // names.h associated with names.frm
#include "ceasy2.h"

#define BEGIN_NEXT     17       // starting command for select_across()
#define BEGIN_PREVIOUS 24       // starting command for select_across()

#define QUERY    (*COMMAND=='Q')
#define NEXT     (*COMMAND=='N')
#define PREVIOUS (*COMMAND=='P')
#define ADD      (*COMMAND=='A')
#define UPDATE   (*COMMAND=='U')
#define DELETE   (*COMMAND=='D')
#define FIRST    (*COMMAND=='F')
#define EXIT     (*COMMAND=='E')

#define FOUND         31
#define _MISSING      32
#define EMPTY         33
#define FULL          34
#define DUPLICATE     35
#define ADDED         36
#define REPLACED      37
#define DELETED       38

char RECORD [265];                  // actual size is 261
char RECORD_KEY [53];

#define RSIZE        sizeof(RECORD)
#define MAXRECORDS   64000/RSIZE    // 240 records

char *RPTR;
int  RX;
int  RXMAX;
int  END_OF_FILE;
int  EXISTS;
int  EXIT_NEXT_PREVIOUS;
int  INTERRUPTED;
char *COMMAND;
char filename[12];

int main(argc,argv)
int argc;
char *argv[];
{
 start_program();

 strcpy(filename,"names.dat");
 if(argc>1)
  {
   strncpy(filename,argv[1],12);
  }

 initialize();

 init_dummy();

 if (read_form ("names") < 0 )
  {
   display_error ("Cannot read ","names.frm");
   stop_program (-1);
  }

 define_fields (FPTR);        // modify FPTR Table in memory
 FAST_DISPLAY = ON;
 restore_text_screen ("names.scr");
 erase_fields (FPTR);
 display_fields (FPTR);

 while (NOT EXIT)
  {
   set_color (BKGND_GRAY);
   clear_line (SL);

   BEGIN_SELECT = 1;

   if( NOT EXIT_NEXT_PREVIOUS )
    {
     while(1)
      {
       COMMAND = select_across ( 3, 8 );
       BEGIN_SELECT = --AC;
       if ( NOT ( UP OR DOWN ) ) break;
      }
    }
   EXIT_NEXT_PREVIOUS = NO;
   INTERRUPTED = NO;

   if(EXIT) break;

   if(FIRST)
    {
     first_record();
     load_fields ( RECORD, FPTR );
     display_fields (FPTR);
     continue;
    }

   if( NOT NEXT AND NOT PREVIOUS )
    {
     set_field ( "NAME", FPTR );
     if( UPDATE && *APTR != SPACE )
      {
       move (APTR, RECORD_KEY, sizeof(RECORD_KEY) );
       FPTR++;
      }
     else
      {
       erase_fields (FPTR);
       display_fields (FPTR);
      }
     event_F[3].function = F3_Key;
     event_F[4].function = F4_Key;

     enter_form (FPTR);

     FPTR =& FIELD[0];

     event_F[3].function = NULL;   // temporarily inhibit F3
     event_F[4].function = NULL;
     if (INTERRUPTED) continue;
    }
   else
    {
     set_field ( "NAME", FPTR );
     if ( *APTR == SPACE )
      {
       COMMAND = " ";
       continue;
      }
    }
   if (ADD OR UPDATE)
    {
     erase ( RECORD, sizeof(RECORD) );
     store_fields ( RECORD, FPTR );
    }
   if (UPDATE)
    {
     if (replace_record() != REPLACED )
      {
       display_message ( "Record not replaced", NULL );
      }
    }
   if (ADD)
    {
     if ( add_record() == DUPLICATE )
       beep();
//     display_message ( "Duplicate Key", NULL );
    }
   if (DELETE)
    {
     if (delete_record() != DELETED )
       display_message ( "Record was NOT deleted", NULL );
    }

   while (NEXT OR PREVIOUS)
    {
     if (NEXT) next_record();
     else previous_record();

     load_fields ( RECORD, FPTR );
     display_fields (FPTR);

     if(NEXT) BEGIN_SELECT = BEGIN_NEXT;
     else BEGIN_SELECT = BEGIN_PREVIOUS;

     COMMAND = select_across ( 3, 8 );
     if (EXIT) break;
     if (NOT NEXT AND NOT PREVIOUS)
      {
       EXIT_NEXT_PREVIOUS = YES;
       break;
      }
    }
  }
 save_file();
 stop_program(0);
 return(0);
}

int F3_Key()
 {
  event_F[3].function = NULL;
  BEGIN_SELECT = 1;
  EXIT_FORM_NOW = YES;
  INTERRUPTED = YES;
  event_F[3].function = F3_Key;
  return (ENTRY_EXIT);
 }

F4_Key()
 {
  EXIT_FORM_NOW = YES;          // terminate current form entry
  return (ENTRY_EXIT);          // terminate data entry form processing
 }

int retrieve (fptr)
form_entry *fptr;
 {
  if (fptr);
  FPTR = &FIELD[0];
  if (HELP_KEY)
   {
    if (NOT ADD)
     {
      scroll_names();
     }
    return (FIELD_REPEAT);
   }
  if( EXIT)                     // terminate form entry if EXIT selected
   {
    EXIT_FORM_NOW = YES;
    return (FORM_EXIT);
   }
  set_field ( "NAME", FPTR );
  if ( *APTR == SPACE )        // repeat entry if entered key is blank
   {
    if (QUERY)
     {
      scroll_names();
      FPTR = &FIELD[0];
      set_field ( "NAME", FPTR );
      move ( APTR, RECORD_KEY, SIZE ); // move NAME to RECORD TABLE
      get_record();
      load_fields ( RECORD, FPTR );
      display_fields ( FPTR );
      EXISTS = YES;
      return (FORM_EXIT);
     }
    else
     {
      display_message ( "Key cannot be blank", NULL );
      return (FIELD_REPEAT);
     }
   }
  FPTR = &FIELD[0];
  set_field ( "NAME", FPTR );
  move ( APTR, RECORD_KEY, SIZE);    // move NAME to RECORD TABLE
  EXISTS = NO;
  if(get_record() == FOUND)           // retrieve record
   {
    load_fields ( RECORD, FPTR );     // populate fields in form
    display_fields ( FPTR );          // display fields in form
    EXISTS = YES;
   }
  else if (QUERY)
   {
    scroll_names();
    set_field ( "NAME", FPTR );
    move ( APTR, RECORD_KEY, SIZE );  // move NAME to RECORD TABLE
    get_record();
    load_fields ( RECORD, FPTR );
    display_fields ( FPTR );
    EXISTS = YES;
   }
  if (ADD AND EXISTS)
   {
    display_error ("Record already exists", NULL);
    return (FORM_EXIT);
   }
  if (QUERY OR DELETE OR NEXT OR PREVIOUS OR FIRST)
   {
    return (FORM_EXIT);              // valid, no input required
   }
  return (FORM_CONTINUE);            // continue with UDATE or ADD
 }

int initialize()
 {
  BKGND_FORM         = BKGND_GRAY;
  BKGND_TIME         = BKGND_GRAY;
  FGND_TIME          = FGND_BLUE;
  FGND_ENTRY         = FGND_BLUE;
  BKGND_ENTRY        = BKGND_BLUE;
  BKGND_HELP         = BKGND_MAGENTA;
  FGND_HELP          = FGND_BLACK;
  AUTO_COMMAND       = OFF;           // select_across not automatic
  WRAP_COMMAND       = ON;
  BKGND_BAR          = BKGND_RED;
  FGND_BAR           = FGND_YELLOW;
  FGND_FIRST         = FGND_BLACK;
  BKGND_COMMAND      = BKGND_CYAN;
  FGND_COMMAND       = FGND_YELLOW;
  BKGND_COLOR        = BKGND_BLUE;


  EXIT_NEXT_PREVIOUS = NO;
  INTERRUPTED        = NO;


  FPTR = &FIELD[0];
  event_F[3].function = F3_Key;        // enable F3
  event_F[4].function = F4_Key;        // enable F4
  enable_time ('C', SL, 66);
  erase ( RECORD, sizeof(RECORD) );
  erase ( RECORD_KEY, sizeof(RECORD_KEY) );
  use_palette ("names.pal");
  return(0);
 }

int scroll_names()
{
  unsigned char *names,
                *i;
  int           w, h, l, c,
                x, keepsize;

  FUNC = 0;
  FPTR = &FIELD[0];
  set_field ("NAME", FPTR);
  w = sizeof(RECORD_KEY);
  h = 10; l = 9; c = 18;

  if (( names=Malloc(240*w)) == NULL)
   {
    display_message ("Cannot Malloc for names",NULL);
    return (FORM_EXIT);
   }
  erase (names, 240*w);
  erase (RECORD, w);
  move (APTR, RECORD_KEY, w);
  END_OF_FILE = NO;
  if (*APTR == SPACE) first_record();
  else
   {
    get_record();
    next_record();
   }
  for(i=names, x=0; !END_OF_FILE && x<240; i+=w, x++)
   {
    move (RECORD, i, w);
    next_record();
   }
  if (x)
   {
    keep_all(1);
    BKGND_WINDOW  = BKGND_CYAN;
    FGND_WINDOW   = FGND_YELLOW;
    FGND_FRAME    = FGND_YELLOW;
    BKGND_FRAME   = BKGND_BLUE;
    BKGND_BAR     = BKGND_RED;
    FGND_BAR      = FGND_YELLOW;
    BKGND_COMMAND = BKGND_RED;
    FGND_COMMAND  = FGND_YELLOW;
    keep_window (1, w, h, l, c);
    VERTICAL_ONLY = ON;
    browse_select ( names, x*w, w, (x<h) ? x : h, l, c);
    VERTICAL_ONLY = OFF;
    set_field ("NAME", FPTR);
    move (LAST_LINE_PTR, APTR, w);
    restore_window (1, w, h, l, c);
    restore_all(1);
    VERTICAL_ONLY = OFF;
   }
  free (names);
  return (FIELD_REPEAT);
}

// DUMMY KEY INDEX FILE INTERFACE ROUTINES BELOW:

int get_record()
{
 if (RXMAX == 0 ) return (EMPTY);
 if ( locate_record() == MISSING ) return(MISSING);
 move ( &RPTR[RX*RSIZE], RECORD, RSIZE );
 return(FOUND);
}

int first_record()
{
 RX=0;
 if ( RXMAX == 0 ) return(EMPTY);
 move ( RPTR, RECORD, RSIZE );
 move ( RPTR, RECORD_KEY, sizeof(RECORD_KEY));
 return(0);
}

int last_record()
{
 if( RXMAX == 0 ) return(EMPTY);
  {
   move (&RPTR[RXMAX*RSIZE], RECORD, RSIZE);
   return(0);
  }
}

int next_record()
{
 END_OF_FILE = NO;
 if (RXMAX == 0) return(EMPTY);
 if ( RX < RXMAX ) RX++;
 else
  {
   END_OF_FILE = YES;
   RX = 0;
  }
 move (&RPTR[RX*RSIZE], RECORD, RSIZE);

 if (RX == 0) return(END_OF_FILE);
 return(0);
}

int previous_record()
{
 if( RXMAX == 0 ) return(EMPTY);
 if( RX > 0 ) RX--;
 else RX = RXMAX;
 move ( &RPTR[RX * RSIZE], RECORD, RSIZE );
 return(0);
}

int add_record()
{
 if (locate_record() == FOUND) return (DUPLICATE);

 if( RXMAX < 239 )
  {
   compare ( RECORD_KEY, &RPTR[RXMAX*RSIZE], sizeof(RECORD_KEY) );
   if(LESS)
    {
     move_right ( &RPTR[RXMAX * RSIZE] + RSIZE-1,
                  &RPTR[(RXMAX+1) * RSIZE] + RSIZE-1,
                  (RXMAX-RX+1) * RSIZE );

     move ( RECORD, &RPTR[RX * RSIZE], RSIZE );
    }
   else
    {
     move ( RECORD, &RPTR[(RXMAX+1)*RSIZE], RSIZE );
    }
   RXMAX++;
   return (ADDED);
  }
 display_error("File is Full!",NULL);

 return (FULL);
}

int delete_record()
{
 if( RXMAX <= 1 ) return(EMPTY);
 if ( locate_record () == MISSING ) return(MISSING);

 move (&RPTR[(RX+1) * RSIZE], &RPTR[RX * RSIZE], (RXMAX-RX) * RSIZE);
 erase ( &RPTR[RXMAX * RSIZE], RSIZE );
 RXMAX--;
 return(DELETED);
}

int replace_record()
{
 if ( RXMAX == 0 ) return (EMPTY);

 if ( locate_record () == MISSING ) return(MISSING);

 move(RECORD, &RPTR[RX * RSIZE], RSIZE );
 return (REPLACED);
}

int locate_record()
{
 if( RXMAX == 0 ) return(MISSING);
 for ( RX=0; RX <= RXMAX; RX++ )
  {
   compare (RECORD_KEY, &RPTR[RX * RSIZE], sizeof(RECORD_KEY));
   if (EQUAL) return (FOUND);
   if (LESS && QUERY )
    {
     if (RX) RX--;
     break;
    }
   if (LESS) break;
  }
 return (MISSING);
}

int init_dummy()
{
 FILE  *fptr;
 int   x;
 char  *j;

 if( (RPTR=(char *)Malloc (RSIZE * MAXRECORDS) ) == NULL)
  {
   display_message ("Cannot Malloc RECORDS", NULL);
   stop_program();
  }

 erase ( RPTR, RSIZE*MAXRECORDS );
 RX = 0;

 if ( (fptr = xopen (filename, "r") ) != NULL) // does file exist?
  {
   fclose(fptr);                    // close file pointer
   read_text (  filename,         // read table records from disk
                RPTR,               // into record table in memory
                RSIZE,              // size of each record in memory
                MAXRECORDS);        // maximum number of records to read

   for ( x=0, j=RPTR;               // x = record count
         *j != SPACE &&
         x < MAXRECORDS;            // continue counting until no key
         j+=RSIZE, x++ )            // advance to next record

   RXMAX=x;                         // RXMAX is maximum record index

  }
 else                               // if no data file, create some records
  {
   move ( "AAAAA", RPTR,sizeof(RECORD_KEY));
   move ( "ZZZZZ", RPTR+RSIZE,50 );
   RXMAX = 1;                       // 2 records created, index: 0-1
  }
 return(0);
}

int save_file()                     // save new record table
{
 write_text ( filename,             // writes table records to text file
             RPTR,                  // table in memory
             RSIZE,                 // maximum width of each record
             MAXRECORDS);           // number of records to write
 return(0);
}
